include \masm32\include\masm32rt.inc
; include \masm32\MasmBasic\MasmBasic.inc		; useful because of deb 1, "MACRO", eax, ecx, edx
.686
.xmm
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 100000

bin2byte_exLib	PROTO: DWORD
ShowCpu	PROTO:DWORD

; ML assembler version 6.15 supports XMM instructions, except the
; instructions MOVSD and CMPSD which are confused with integer string
; instructions with the same names. ([url=http://www.masm32.com/board/index.php?topic=12719.msg98468#msg98468]Greg Lyon[/url])

MOVSD_ MACRO A, B
  DB 0F2H
  MOVUPS A, B
ENDM

CMPSD_ MACRO A, B, C
  DB  0F2H
  CMPPS A, B, C
ENDM

.code
t0	db "00000000", 0, "xxxxxxxxxxxxxxxxxxxxxxx"
tm	db "01010101", 0, "xxxxxxxxxxxxxxxxxxxxxxx"
t1	db "11111111", 0, "xxxxxxxxxxxxxxxxxxxxxxx"

start:	invoke ShowCpu, 1
	print chr$(13, 10)
;	push offset t1
;	call BinTest
;	print str$(eax)
;	getkey
;	exit
	push offset t0
	call BinValSSE

	push offset tm
	call BinValLingo

	REPEAT 3
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call Bin2Dw
	push offset tm
	call Bin2Dw
	push offset t1
	call Bin2Dw
	counter_end
	print str$(eax), 9, "cycles for Bin2Dw       (drizz+JJ, variable size)", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinValSSE_bt
	push offset tm
	call BinValSSE_bt
	push offset t1
	call BinValSSE_bt
	counter_end
	print str$(eax), 9, "cycles for BinValSSE_bt (JJ, variable size)", 13, 10

	if 0
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinVal2
	push offset tm
	call BinVal2
	push offset t1
	call BinVal2
	counter_end
	print str$(eax), 9, "cycles for BinVal2 (non-SSE2)", 13, 10
	endif
	if 0
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinValSSE_wt
	push offset tm
	call BinValSSE_wt
	push offset t1
	call BinValSSE_wt
	counter_end
	print str$(eax), 9, "cycles for BinValSSE_wt", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinValSSE
	push offset tm
	call BinValSSE
	push offset t1
	call BinValSSE
	counter_end
	print str$(eax), 9, "cycles for BinValSSE", 13, 10
	endif
	if 1
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0	; 0 only
	call BinValJJ
	push offset tm	; mixed
	call BinValJJ
	push offset t1	; 1 only
	call BinValJJ
	counter_end
	print str$(eax), 9, "cycles for BinValJJ (SSE2)", 13, 10
	endif
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0	; 0 only
	call BinValJL
	push offset tm	; mixed
	call BinValJL
	push offset t1	; 1 only
	call BinValJL
	counter_end
	print str$(eax), 9, "cycles for BinValJL (SSE2)", 13, 10

	if 1
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0	; 0 only
	call BinValLingo
	push offset tm	; mixed
	call BinValLingo
	push offset t1	; 1 only
	call BinValLingo
	counter_end
	print str$(eax), 9, "cycles for BinValLingo (SSE2)", 13, 10
	endif

	if 0
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0	; 0 only
	call BinVal1
	push offset tm	; mixed
	call BinVal1
	push offset t1	; 1 only
	call BinVal1
	counter_end
	print str$(eax), 9, "cycles for BinVal1", 13, 10
	endif

	if 0
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinVal3
	push offset tm
	call BinVal3
	push offset t1
	call BinVal3
	counter_end
	print str$(eax), 9, "cycles for BinVal3", 13, 10
	endif

	if 0
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call BinToDw
	push offset tm
	call BinToDw
	push offset t1
	call BinToDw
	counter_end
	print str$(eax), 9, "cycles for BinToDw   (drizz)", 13, 10
	endif
	if 0
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call b2dw1
	push offset tm
	call b2dw1
	push offset t1
	call b2dw1
	counter_end
	print str$(eax), 9, "cycles for b2dw1 (Lingo)", 13, 10
	endif
	if 1
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call simd_bin2byte
	push offset tm
	call simd_bin2byte
	push offset t1
	call simd_bin2byte
	counter_end
	print str$(eax), 9, "cycles for simd_bin2byte", 13, 10
	endif
	if 1
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	push offset t0
	call simd_bin2byteB
	push offset tm
	call simd_bin2byteB
	push offset t1
	call simd_bin2byteB
	counter_end
	print str$(eax), 9, "cycles for simd_bin2byteB", 13, 10
	endif

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
	invoke bin2byte_exLib, offset t0
	test eax, eax
	jns @F
	inc eax
	@@:
	invoke bin2byte_exLib, offset tm
	test eax, eax
	jns @F
	inc eax
	@@:
	invoke bin2byte_exLib, offset t1
	test eax, eax
	jns @F
	inc eax
	@@:
	counter_end
	print str$(eax), 9, "cycles for bin2byte_exLib", 13, 10, 10
	ENDM

; Tests for correctness (only one algo at a time, sorry, e.g. simd_bin2byte, bin2byte_exLib, BinValSSE, BinVal3, BinValSSE_bt)
if 0
  Algo equ BinValLingo
else
  Algo equ BinValJJ
endif
  tmp$ CATSTR <print chr$("Testing >, Algo, < (2 lines must match):", 13, 10, "0, 3, 12, 48, 192, 255, over8: -1, 1431655765", 13, 10)>
  tmp$
	; push chr$("01111101010101010101010101000001y")
	push chr$("00000000y")
	; push chr$("11110000y")
	call Algo
	print str$(eax), ", "

	push chr$("00000011y")
	call Algo
	print str$(eax), ", "

	push chr$("00001100y")
	call Algo
	print str$(eax), ", "

	push chr$("00110000y")
	call Algo
	print str$(eax), ", "

	push chr$("11000000y")
	call Algo
	print str$(eax), ", "

	push chr$("11111111y")
	call Algo
	print str$(eax), ", over8: "

	push chr$("11111111111111111111111111111111y")
	call Algo
	print str$(eax), ", "

	push chr$("01010101010101010101010101010101y")
	.data
	v1	dd 01010101010101010101010101010101y
	.code
	call Algo
	push eax

;	push chr$("00001100y")
;	call Algo
;	print str$(eax), ", "

;	push chr$("00110000y")
;	call Algo
;	print str$(eax), ", "

	print str$(eax), 13, 10
	pop eax
	if 0
	.if eax!=1431655765
		print "Last item different: Apparently, the algo does not recognize formats different", 13, 10,\
		"from '10101010', i.e. it needs fixed 8 chars or 8 chars plus zero delimiter"
	.endif
	endif
	print chr$(13, 10)	;, "Code size:", 13, 10)
	mov eax, Bin2Dw_END
	sub eax, Bin2Dw
	print str$(eax), " bytes Bin2Dw (drizz+JJ)", 13, 10

	mov eax, BinValSSE_bt_END
	sub eax, BinValSSE_bt
	print str$(eax), " bytes BinValSSE_bt (JJ)", 13, 10

;	mov eax, BinValSSE_END
;	sub eax, BinValSSE
;	print str$(eax), " bytes BinValSSE", 13, 10

	mov eax, BinValJJ_END
	sub eax, BinValJJ
	print str$(eax), " bytes BinValJJ", 13, 10

	mov eax, BinValJL_END
	sub eax, offset bvMask	; BinValJL
	print str$(eax), " bytes BinValJL", 13, 10

	mov eax, BinValLingo_END
	sub eax, offset mask1		; not BinValLingo, because mask1 is initialised data
	print str$(eax), " bytes BinValLingo (Lingo)", 13, 10

	if 0
	mov eax, BinVal1_END
	sub eax, BinVal1
	print str$(eax), " bytes BinVal1 (JJ)", 13, 10
	endif

;	mov eax, BinVal2_END
;	sub eax, BinVal2
;	print str$(eax), " bytes BinVal2 (JJ)", 13, 10

;	mov eax, BinVal3_END
;	sub eax, BinVal3
;	print str$(eax), " bytes BinVal3", 13, 10

;	mov eax, simd_bin2byte_END
;	sub eax, simd_bin2byte
;	print str$(eax), " bytes simd_bin2byte (qWord)", 13, 10

	mov eax, simd_bin2byteB_END
	sub eax, simd_bin2byteB
	print str$(eax), " bytes simd_bin2byteB (qWord+JJ)", 13, 10

;	mov eax, BinToDw_END
;	sub eax, BinToDw
;	print str$(eax), " bytes BinToDw", 13, 10

;	mov eax, b2dw1_END
;	sub eax, b2dw1
;	print str$(eax), " bytes b2dw1", 13, 10

	mov eax, bin2byte_exLib_END
	sub eax, bin2byte_exLib
	print str$(eax), " bytes bin2byte_ex (Masm32 library)", 13, 10

	inkey chr$(9, 9, 9, 9, 9, 9, " - hit any key -")
	exit

; ################### Algos ############################

align 16	; [url=http://www.masm32.com/board/index.php?topic=12719.msg98094#msg98094]qWord[/url]
simd_bin2byte proc 	; psz:DWORD
	mov eax, [esp+4]
	; MOVSD_ xmm0, QWORD ptr [eax]	; mlv615 and JWasm complain: Tmp_File.asm(304) : Error A2084: Invalid operand size for instruction
	movlps xmm0, QWORD ptr [eax]	; workaround; OPT_Assembler JWasm
	pxor xmm1, xmm1
	psllq xmm0, 7
	punpcklbw xmm0, xmm1
	pshuflw xmm0, xmm0, 00011011y
	pshufhw xmm0, xmm0, 00011011y
	packuswb xmm0, xmm0
	pshufd xmm0, xmm0, 011100001y
	pmovmskb eax, xmm0
	movzx eax, al
	ret 4
simd_bin2byte endp
simd_bin2byte_END:

align 16
simd_bin2byteB proc 	; psz:DWORD
	pop ecx
	pop eax
	; MOVSD_ xmm0, QWORD ptr [eax]	; mlv615 and JWasm complain: Tmp_File.asm(304) : Error A2084: Invalid operand size for instruction
	movlps xmm0, QWORD ptr [eax]	; workaround
	pxor xmm1, xmm1
	psllq xmm0, 7
	punpcklbw xmm0, xmm1
	pshuflw xmm0, xmm0, 00011011y
	pshufhw xmm0, xmm0, 00011011y
	packuswb xmm0, xmm0
	pshufd xmm0, xmm0, 011100001y
	pmovmskb eax, xmm0
	movzx eax, al
	jmp ecx
simd_bin2byteB endp
simd_bin2byteB_END:

;BinTest proc
;	pop ecx			; ret address
;	pop edx			; pointer to src$
;	int 3
;	mov eax, [edx]
;	and eax, 01010101h
;	mov edx, [edx+4]
;	and edx, 01010101h
;	shl edx, 1
;	or eax, edx
;	jmp ecx
;BinTest endp

align 16
BinVal0 proc 	; lpSrc			; 54 bytes; 8 bits fixed length
	pop ecx			; ret address
	pop edx			; pointer to src$
	mov eax, "1111"		; bits set
	movd xmm2, eax
	pshufd xmm2, xmm2, 0	; "1" propagated to xmm2
	mov eax, [edx]
	bswap eax
	movd xmm0, eax
	mov eax, [edx+4]
	bswap eax
	movd xmm1, eax
	punpckldq xmm1, xmm0	; interleave low dwords
	pcmpeqb xmm1, xmm2	; compare packed bytes to "1"
	pmovmskb eax, xmm1	; set byte mask 0 in edx
	; movzx eax, al		; no longer needed
	jmp ecx
BinVal0 endp
BinVal0_END:

align 16
BinValJJ proc 	; lpSrc				; 76 bytes including the mask; 8 bits fixed length
	cmp byte ptr bvjTable[4], 0		; table already created?
	je bvjCreate
bvjChk:	pop ecx				; ret address
	pop edx				; pointer to src$
	movlps xmm0, qword ptr [edx]		; get 8 chars
	pcmpeqb xmm0, oword ptr [bvjMask]	; compare packed bytes to "1" (oword = xmmword)
	pmovmskb eax, xmm0		; set byte mask 0 in edx
	movzx eax, byte ptr [bvjTable+eax]
	jmp ecx
.data?
align 16
bvjMask	dd 4 dup(?)
bvjTable	db 256 dup(?)
.code
bvjCreate:	push edi
	push esi
	mov edi, offset bvjMask
	mov eax, "1111"
	stosd
	stosd
	stosd
	stosd
	xor ecx, ecx
bvjLoop:	m2m esi, 8	; set inner counter
	mov edx, ecx	; the source word
@@:	shr edx, 1		; [url=http://www.masm32.com/board/index.php?topic=12722.msg98158#msg98158]ex rol dx, 1[/url]: get a carry flag in case the high order bit is set
	rcl eax, 1		; ex rcr ax, 1; and pull it in from the left
	dec esi
	jne @B
	stosb		; store the byte in bvjTable
	inc cl		; ecx lobyte, eq for 256
	jne bvjLoop
	pop esi
	pop edi
	jmp bvjChk	; done, start using the table
BinValJJ endp
BinValJJ_END:

align 16	; absolutely needed, otherwise pcmpeqb chokes
bvMask dd "1111", "1111"
BinValJL proc 	; lpSrc			; 45 bytes including the mask; 8 bits fixed length
	pop ecx			; ret address
	pop edx			; pointer to src$
	mov eax, [edx]		; get 4 chars
	bswap eax
	movd xmm0, eax
	mov eax, [edx+4]		; get 4 more
	bswap eax
	movd xmm1, eax
	punpckldq xmm1, xmm0	; interleave low dwords
	; compare packed bytes to "1"
	pcmpeqb xmm1, oword ptr [bvMask]	; oword aka xmmword
	pmovmskb eax, xmm1	; set byte mask 0 in edx
	jmp ecx
BinValJL endp
BinValJL_END:

align 16
; mask1 dq 0Fh,0	; Lingo's version
mask1 dd "1111", "1111"

BinValLingo proc 	; lpSrc
	pop	ecx		
	pop	eax		
	mov	edx, [eax]
	mov	eax, [eax+4]
	bswap	edx
	bswap eax
	movd	xmm0, edx
	movd	xmm1, eax
	punpckldq	xmm1, xmm0
	pcmpeqb		xmm1, oword ptr [mask1]	; oword aka xmmword
	pmovmskb	eax, xmm1	
	; and eax, 0FFh						; no longer necessary (and, by the way, NOT faster than movzx eax, al ;-)
	jmp ecx
BinValLingo endp
BinValLingo_END:

align 16
BinToDw proc 	; pszbinstr:DWORD
	mov edx, [esp+1*4]
	xor eax, eax
	jmp @F
	.Repeat
		and ecx, 1
		lea eax, [eax*2+ecx]
	@@:	movzx ecx, byte ptr [edx]
		inc edx
		test ecx, ecx
	.Until Zero?
	ret 1*4
BinToDw endp
BinToDw_END:

align 16
Bin2Dw proc 	; pszbinstr:DWORD		; this one stops when char is not "1" or "0"
	mov edx, [esp+4]		; credits [url=http://www.masm32.com/board/index.php?topic=4709.msg35458#msg35458]drizz[/url] with mods by jj2007
	xor eax, eax
	push ecx			; MasmBasic preserves ecx ;-)
	jmp byte1

@@:	and ecx, 1
	lea eax, [eax*2+ecx]	; multiply eax by 2, add one if the char was "1"
byte1:	mov cl, [edx]		; get next char
	inc edx
	cmp cl, "1"
	ja @F
	cmp cl, "0"
	jae @B

@@:	pop ecx
	ret 4
Bin2Dw endp
Bin2Dw_END:	; exactly 32 bytes long

       align	16
       db	90h
       
b2dw1 proc	; lpszbinstr:dword
	mov edx, [esp+4]
	mov ecx, 30h
	xor eax,eax
	cmp cl, [edx]
	ja @j
	@@:
	adc eax, eax
	cmp cl, [edx+1]
	@j:
	ja @f
	adc eax, eax
	cmp cl, [edx+2]
	ja @f
	adc eax, eax
	cmp cl, [edx+3]
	ja @f
	adc eax, eax
	cmp cl, [edx+4]
	ja @f
	adc eax, eax
	cmp cl, [edx+5]
	ja @f
	adc eax, eax
	cmp cl, [edx+6]
	ja @f
	adc eax, eax
	cmp cl, [edx+7]
	ja @f
	adc eax, eax
	cmp cl, [edx+8]
	ja @f
	adc eax, eax
	cmp cl, [edx+9]
	ja @f
	adc eax, eax
	cmp cl, [edx+10]
	ja @f
	adc eax, eax
	cmp cl, [edx+11]
	ja @f
	adc eax, eax
	cmp cl, [edx+12]
	ja @f
	adc eax, eax
	cmp cl, [edx+13]
	ja @f
	adc eax, eax
	cmp cl, [edx+14]
	ja @f
	adc eax, eax
	cmp cl, [edx+15]
	ja @f
	adc eax, eax
	cmp cl, [edx+16]
	lea edx, [edx+16]
	jna @b
	@@:
	ret 4
b2dw1 endp
b2dw1_END:

align 16
BinValSSE_bt proc 	; lpSrc		; this one stops when char is not 1 or 0
	push edi
	push ebx
	mov edi, offset btTable
	mov ebx, [edi+4]		; test if table was already created (clears also outer counter)
	test ebx, ebx
	je btCreate

btChk:	mov edi, [esp+12]
	mov eax, "0000"		; bit clear
	movd xmm0, eax
	pshufd xmm0, xmm0, 0	; now in xmm2
	mov eax, "1111"		; bit set
	movd xmm1, eax
	pshufd xmm1, xmm1, 0	; now in xmm2

	movdqu xmm2, [edi]		; get 16 bytes of the string
	movdqa xmm3, xmm2	; save a copy
	pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	pmovmskb edx, xmm2	; set byte mask 0 in edx
	pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	pmovmskb eax, xmm3	; set byte mask 1 in eax
	xor ebx, ebx
	movzx ecx, ah
	mov bl, btTable[ecx]
	movzx ecx, al
	mov bh, btTable[ecx]
	shl ebx, 16		; move to hiword
	xor eax, edx
	not eax
	bsf ecx, eax		; ecx = # bits used
	.if ecx>8
	  push ecx
	  movdqu xmm2, [edi+16]	; get next 16 bytes
	  movdqa xmm3, xmm2	; save a copy
	  pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	  pmovmskb edx, xmm2	; set byte mask 0 in edx
	  pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	  pmovmskb eax, xmm3	; set byte mask 1 in eax
	  movzx ecx, ah
	  add bl, btTable[ecx]
	  movzx ecx, al
	  add bh, btTable[ecx]
	  xor eax, edx
	  not eax
	  bsf ecx, eax
	  pop eax
	  add ecx, eax		; # bits used
	.endif
	sub ecx, 32
	neg ecx
	shr ebx, cl		; shift by # of bits
	mov eax, ebx		; retval
	pop ebx
	pop edi
	ret 4

.data?
btTable	db 256 dup(?)

.code
btCreate:	m2m esi, 8	; set inner counter
	mov edx, ebx	; the source word

@@:	shr edx, 1		; [url=http://www.masm32.com/board/index.php?topic=12722.msg98158#msg98158]ex rol dx, 1[/url]: get a carry flag in case the high order bit is set
	rcl eax, 1		; ex rcr ax, 1; and pull it in from the left
	dec esi
	jne @B
	stosb		; store the word in btTable
	inc bl
	jne btCreate
;	mov edi, offset btTable
;	int 3
;	mov ebx, ebx
	jmp btChk		; done, start using the table
BinValSSE_bt endp
BinValSSE_bt_END:

align 16
BinValSSE_wt proc 	; lpSrc			; this one stops when char is not 1 or 0
	push edi
	push ebx
	mov edi, offset wdTable
	mov ebx, [edi+4]		; test if table was already created (clears also outer counter)
	test ebx, ebx
	je wtCreate

wtChk:	mov edi, [esp+12]
	mov eax, "0000"		; bit clear
	movd xmm0, eax
	pshufd xmm0, xmm0, 0	; now in xmm2
	mov eax, "1111"		; bit set
	movd xmm1, eax
	pshufd xmm1, xmm1, 0	; now in xmm2

	movdqu xmm2, [edi]		; get 16 bytes of the string
	movdqa xmm3, xmm2	; save a copy
	pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	pmovmskb edx, xmm2	; set byte mask 0 in edx
	pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	pmovmskb eax, xmm3	; set byte mask 1 in eax
	movzx ebx, wdTable[2*eax]
	shl ebx, 16		; move to hiword
	xor eax, edx
	not eax
	bsf ecx, eax		; ecx = # bits used
	.if ecx>8
	  push ecx
	  movdqu xmm2, [edi+16]	; get next 16 bytes
	  movdqa xmm3, xmm2	; save a copy
	  pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	  pmovmskb edx, xmm2	; set byte mask 0 in edx
	  pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	  pmovmskb eax, xmm3	; set byte mask 1 in eax
	  movzx ecx, wdTable[2*eax]
	  add ebx, ecx
	  xor eax, edx
	  not eax
	  bsf ecx, eax
	  pop eax
	  add ecx, eax		; # bits used
	.endif
	sub ecx, 32
	neg ecx
	shr ebx, cl		; shift by # of bits
	mov eax, ebx		; retval
	pop ebx
	pop edi
	ret 4

.data?
wdTable	dw 65536 dup(?)

.code
wtCreate:	m2m esi, 16	; set inner counter
	mov edx, ebx	; the source word

@@:	shr edx, 1		; [url=http://www.masm32.com/board/index.php?topic=12722.msg98158#msg98158]ex rol dx, 1[/url]: get a carry flag in case the high order bit is set
	rcl eax, 1		; ex rcr ax, 1; and pull it in from the left
	dec esi
	jne @B
	stosw		; store the word in wdTable
	inc bx
	jne wtCreate
	jmp wtChk		; done, start using the table
BinValSSE_wt endp
BinValSSE_wt_END:

align 16
BinValSSE proc 	; lpSrc			; this one stops when char is not 1 or 0
	push edi
	push ebx
	mov edi, [esp+12]
	mov eax, "0000"		; bit clear
	movd xmm0, eax
	pshufd xmm0, xmm0, 0	; now in xmm2
	mov eax, "1111"		; bit set
	movd xmm1, eax
	pshufd xmm1, xmm1, 0	; now in xmm2

	movdqu xmm2, [edi]		; get 16 bytes of the string
	movdqa xmm3, xmm2	; save a copy
	pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	pmovmskb edx, xmm2	; set byte mask 0 in edx
	pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	pmovmskb eax, xmm3	; set byte mask 1 in eax
	mov ebx, eax
	xor eax, edx
	not eax
	bsf ecx, eax		; ecx = # bits used
	.if ecx>8
	  push ecx
	  movdqu xmm2, [edi+16]	; get next 16 bytes
	  movdqa xmm3, xmm2	; save a copy
	  pcmpeqb xmm2, xmm0	; compare packed bytes to "0"
	  pmovmskb edx, xmm2	; set byte mask 0 in edx
	  pcmpeqb xmm3, xmm1	; compare packed bytes to "1"
	  pmovmskb eax, xmm3	; set byte mask 1 in eax
	  mov ecx, eax
	  shl ecx, 16
	  add ebx, ecx
	  xor eax, edx
	  not eax
	  bsf ecx, eax
	  pop eax
	  add ecx, eax		; # bits used
	.endif
	sub ecx, 32
	neg ecx
	shl ebx, cl		; shift by # of bits
	mov edx, ebx

	mov eax, edx
	shr  eax,1
	and  edx,055555555h
	and  eax,055555555h
	lea  eax,[2*edx+eax]
	mov  edx,eax
	shr  eax,2
	and  edx,033333333h
	and  eax,033333333h
	lea  eax,[4*edx+eax]
	mov  edx,eax
	shr  eax,4
	and  edx,0F0F0F0Fh
	and  eax,0F0F0F0Fh
	shl  edx,4
	add  eax,edx
	bswap eax

	pop ebx
	pop edi
	ret 4

BinValSSE endp
BinValSSE_END:

align 16
BinValX proc 	; lpSrc			; 44 bytes; this one stops when char is not 1 or 0
	mov edx, [esp+4]		; slow, but 1...32 bits usable
	or eax, -1
	mov ecx, eax
L1:	inc eax			; eax is zero on loop entry
@@:
	inc ecx
	shl eax, 1
	cmp byte ptr [edx+ecx], "0"
	je @B
	cmp byte ptr [edx+ecx], "1"
	je L1
	cmp ecx, 32	; carry set for 0...31, inverted with cmc
	jb @F
	cmp byte ptr [edx], "1"	; set if "0"
@@:	cmc
	rcr eax, 1
	ret 4
BinValX endp
BinValX_END:

align 16
BinVal1 proc 	; lpSrc:DWORD		; this one stops when char is not 1 or 0
	mov edx, [esp+4]
	or eax, -1
	dec edx
L1:	inc eax
L2:
	inc edx
	shl eax, 1
	cmp byte ptr [edx], "0"
	je L2
	cmp byte ptr [edx], "1"
	je L1
	shr eax, 1
	ret 4
BinVal1 endp
BinVal1_END:


align 16
BinVal2 proc 	; lpSrc
	pop ecx		; ret address
	pop eax		; pointer to src$
	mov edx, [eax]	; first 4 bytes of string
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F		; 2 cycles faster than sbb eax, -1
	inc eax
@@:	shl eax, 4		; shift the nibble up, same as xchg al, ah but faster
	mov edx, [esp-4]	; we have popped the pointer, but it's still hanging around
	mov edx, [edx+4]	; next 4 bytes of string
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	jmp ecx
BinVal2 endp
BinVal2_END:

align 16
BinVal2a proc 	; lpSrc
	push ecx			; not saving ecx is slower
	mov ecx, [esp+8]
	mov edx, [ecx]
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F		; 2 cycles faster than sbb eax, -1
	inc eax
@@:	shl eax, 4
	mov edx, [ecx+4]
	cmp dl, "1"
	jne @F
	add eax, 8	; inc eax
@@:	cmp dh, "1"
	jne @F
	add eax, 4	; 2
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2	; 8
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	pop ecx
	ret 4
;bvpError:	or eax, -1
;	jmp @B
BinVal2a endp
BinVal2a_END:

xs = 1
align 16
BinVal3 proc 	; lpSrc
;	int 3
	mov eax, [esp+4]
	mov edx, [eax]
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	shl eax, 4
	mov edx, [esp+4]
	mov edx, [edx+4]
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	ret 4
;bvpError:	or eax, -1
;	jmp @B
BinVal3 endp
BinVal3_END:

align 16
BinVal4 proc 	; lpSrc
	mov edx, [esp+4]
	mov edx, [edx]
	xor eax, eax
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	shl eax, 4
	mov edx, [esp+4]
	mov edx, [edx+4]
	cmp dl, "1"
	jne @F
	add eax, 8
@@:	cmp dh, "1"
	jne @F
	add eax, 4
@@:	bswap edx
	cmp dl, "1"
	jne @F
	add eax, 2
@@:	cmp dh, "1"
	jne @F
	inc eax
@@:	ret 4
BinVal4 endp
BinVal4_END:

OPTION PROLOGUE : NONE
OPTION EPILOGUE : NONE
align 16
bin2byte_exLib proc lpword:DWORD

    mov eax, [esp+4]

    cmp BYTE PTR [eax+0], "0"
    jne pass10
    cmp BYTE PTR [eax+1], "0"
    jne pass11
    cmp BYTE PTR [eax+2], "0"
    jne pass12
    cmp BYTE PTR [eax+3], "0"
    jne pass13
    ; -------------------
    mov eax, 0 ; 0000
    jmp nxt
    ; -------------------
  align 4
  pass13:
    ; -------------------
    mov eax, 16 ; 0001
    jmp nxt
    ; -------------------
  align 4
  pass12:
    cmp BYTE PTR [eax+3], "0"
    jne pass14
    ; -------------------
    mov eax, 32 ; 0010
    jmp nxt
    ; -------------------
  align 4
  pass14:
    ; -------------------
    mov eax, 48 ; 0011
    jmp nxt
    ; -------------------
  align 4
  pass11:
    cmp BYTE PTR [eax+2], "0"
    jne pass15
    cmp BYTE PTR [eax+3], "0"
    jne pass16
    ; -------------------
    mov eax, 64 ; 0100
    jmp nxt
    ; -------------------
  align 4
  pass16:
    ; -------------------
    mov eax, 80 ; 0101
    jmp nxt
    ; -------------------
  align 4
  pass15:
    cmp BYTE PTR [eax+3], "0"
    jne pass17
    ; -------------------
    mov eax, 96 ; 0110
    jmp nxt
    ; -------------------
  align 4
  pass17:
    ; -------------------
    mov eax, 112 ; 0111
    jmp nxt
    ; -------------------
  align 4
  pass10:
    cmp BYTE PTR [eax+1], "0"
    jne pass18
    cmp BYTE PTR [eax+2], "0"
    jne pass19
    cmp BYTE PTR [eax+3], "0"
    jne pass110
    ; -------------------
    mov eax, 128 ; 1000
    jmp nxt
    ; -------------------
  align 4
  pass110:
    ; -------------------
    mov eax, 144 ; 1001
    jmp nxt
    ; -------------------
  align 4
  pass19:
    cmp BYTE PTR [eax+3], "0"
    jne pass111
    ; -------------------
    mov eax, 160 ; 1010
    jmp nxt
    ; -------------------
  align 4
  pass111:
    ; -------------------
    mov eax, 176 ; 1011
    jmp nxt
    ; -------------------
  align 4
  pass18:
    cmp BYTE PTR [eax+2], "0"
    jne pass112
    cmp BYTE PTR [eax+3], "0"
    jne pass113
    ; -------------------
    mov eax, 192 ; 1100
    jmp nxt
    ; -------------------
  align 4
  pass113:
    ; -------------------
    mov eax, 208 ; 1101
    jmp nxt
    ; -------------------
  align 4
  pass112:
    cmp BYTE PTR [eax+3], "0"
    jne pass114
    ; -------------------
    mov eax, 224 ; 1110
    jmp nxt
    ; -------------------
  align 4
  pass114:
    ; -------------------
    mov eax, 240 ; 1111
    jmp nxt
    ; -------------------

; ******************************************
; ******************************************
; ******************************************

  align 4
  nxt:

    mov ecx, [esp+4]
    add ecx, 4

    cmp BYTE PTR [ecx+0], "0"
    jne lbl0
    cmp BYTE PTR [ecx+1], "0"
    jne lbl1
    cmp BYTE PTR [ecx+2], "0"
    jne lbl2
    cmp BYTE PTR [ecx+3], "0"
    jne lbl3
    ; -------------------
    ;;; add eax, 0
    ret 4
    ; -------------------
  align 4
  lbl3:
    ; -------------------
    add eax, 1
    ret 4
    ; -------------------
  align 4
  lbl2:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl4
    ; -------------------
    add eax, 2
    ret 4
    ; -------------------
  align 4
  lbl4:
    ; -------------------
    add eax, 3
    ret 4
    ; -------------------
  align 4
  lbl1:
    cmp BYTE PTR [ecx+2], "0"
    jne lbl5
    cmp BYTE PTR [ecx+3], "0"
    jne lbl6
    ; -------------------
    add eax, 4
    ret 4
    ; -------------------
  align 4
  lbl6:
    ; -------------------
    add eax, 5
    ret 4
    ; -------------------
  align 4
  lbl5:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl7
    ; -------------------
    add eax, 6
    ret 4
    ; -------------------
  align 4
  lbl7:
    ; -------------------
    add eax, 7
    ret 4
    ; -------------------
  align 4
  lbl0:
    cmp BYTE PTR [ecx+1], "0"
    jne lbl8
    cmp BYTE PTR [ecx+2], "0"
    jne lbl9
    cmp BYTE PTR [ecx+3], "0"
    jne lbl10
    ; -------------------
    add eax, 8
    ret 4
    ; -------------------
  align 4
  lbl10:
    ; -------------------
    add eax, 9
    ret 4
    ; -------------------
  align 4
  lbl9:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl11
    ; -------------------
    add eax, 10
    ret 4
    ; -------------------
  align 4
  lbl11:
    ; -------------------
    add eax, 11
    ret 4
    ; -------------------
  align 4
  lbl8:
    cmp BYTE PTR [ecx+2], "0"
    jne lbl12
    cmp BYTE PTR [ecx+3], "0"
    jne lbl13
    ; -------------------
    add eax, 12
    ret 4
    ; -------------------
  align 4
  lbl13:
    ; -------------------
    add eax, 13
    ret 4
    ; -------------------
  align 4
  lbl12:
    cmp BYTE PTR [ecx+3], "0"
    jne lbl14
    ; -------------------
    add eax, 14
    ret 4
    ; -------------------
  align 4
  lbl14:
    ; -------------------
    add eax, 15
    ret 4
    ; -------------------

  notfound:
    or eax, -1
    ret 4

bin2byte_exLib endp
bin2byte_exLib_END:

ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD

	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

end start
OPT_WAIT	0
OPT_Tmp2Asm	1
OPT_DelTmp	0

Timings
Intel(R) Celeron(R) M CPU        420  @ 1.60GHz (SSE3)

160     cycles for Bin2Dw       (drizz+JJ, variable size)
76      cycles for BinValSSE_bt (JJ, variable size)
29      cycles for BinVal0 (SSE2)
23      cycles for BinValJL (SSE2)
25      cycles for BinValLingo (SSE2)
39      cycles for simd_bin2byte
31      cycles for simd_bin2byteB
62      cycles for bin2byte_exLib